> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/salesforce/page-manipulation/split.md).

# Extracting pages from PDF using JavaScript

Learn how to download specific pages from a document using the extractPages function. Find out how to easily extract only the pages you need. Salesforce WebViewer adds accurate, reliable document proc

If the user only wants to download part of a document, the [extractPages](https://sdk.apryse.com/api/web/Core.Document.html#extractPages) function can be used to download specific pages. For example:

{% tabs %}
{% tab title="JavaScript (SDK v8.0+)" %}
{% code lineNumbers="true" %}

```js
// config.js
const { documentViewer, annotationManager } = instance.Core;

documentViewer.addEventListener('documentLoaded', async () => {
  const doc = documentViewer.getDocument();
  const pagesToExtract = [2, 3];

  // only include annotations on the pages to extract
  const annotList = annotationManager.getAnnotationsList().filter(annot => pagesToExtract.indexOf(annot.PageNumber) > -1);
  const xfdfString = await annotationManager.exportAnnotations({ annotList });
  const data = await doc.extractPages(pagesToExtract, xfdfString);
  const arr = new Uint8Array(data);

  //optionally save the blob to a file or upload to a server
  const blob = new Blob([arr], { type: 'application/pdf' });
});
```

{% endcode %}

[WebViewerInstance](https://sdk.apryse.com/api/web/WebViewerInstance.html) [DocumentViewer.getDocument](https://sdk.apryse.com/api/web/Core.DocumentViewer.html#getDocument__anchor) [Document.extractPages](https://sdk.apryse.com/api/web/Core.Document.html#extractPages) [AnnotationManager.getAnnotationsList](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#getAnnotationsList__anchor) [AnnotationManager.exportAnnotations](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#exportAnnotations__anchor)
{% endtab %}

{% tab title="JavaScript (SDK v6.0+)" %}
{% code lineNumbers="true" %}

```js
// config.js
const { docViewer, annotManager } = instance;

docViewer.on('documentLoaded', async () => {
  const doc = docViewer.getDocument();
  const pagesToExtract = [2, 3];

  // only include annotations on the pages to extract
  const annotList = annotManager.getAnnotationsList().filter(annot => pagesToExtract.indexOf(annot.PageNumber) > -1);
  const xfdfString = await annotManager.exportAnnotations({ annotList });
  const data = await doc.extractPages(pagesToExtract, xfdfString);
  const arr = new Uint8Array(data);

  //optionally save the blob to a file or upload to a server
  const blob = new Blob([arr], { type: 'application/pdf' });
});
```

{% endcode %}

[WebViewerInstance](https://sdk.apryse.com/api/web/WebViewerInstance.html) [DocumentViewer.getDocument](https://sdk.apryse.com/api/web/Core.DocumentViewer.html#getDocument__anchor) [Document.extractPages](https://sdk.apryse.com/api/web/Core.Document.html#extractPages) [AnnotationManager.getAnnotationsList](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#getAnnotationsList__anchor) [AnnotationManager.exportAnnotations](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#exportAnnotations__anchor)
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/salesforce/page-manipulation/split.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
